// =====================================================================================================================
//  fennec-test, a program to execute unit tests for fennec
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_CONTAINERS_H
#define FENNEC_TEST_CONTAINERS_H

#include "containers/test_array.h"
#include "containers/test_bintree.h"
#include "containers/test_deque.h"
#include "containers/test_dynarray.h"
#include "containers/test_graph.h"
#include "containers/test_list.h"
#include "containers/test_map.h"
#include "containers/test_object_pool.h"
#include "containers/test_optional.h"
#include "containers/test_priority_queue.h"
#include "containers/test_rdtree.h"
#include "containers/test_sequence.h"
#include "containers/test_set.h"
#include "containers/test_tuple.h"

namespace fennec::test
{

	inline void fennec_test_containers()
	{
		fennec_test_subheader("optional tests");
		fennec_test_spacer(2);
		fennec_test_containers_optional();
		fennec_test_spacer(3);

		fennec_test_subheader("tuple tests");
		fennec_test_spacer(2);
		fennec_test_containers_tuple();
		fennec_test_spacer(3);

		fennec_test_subheader("array tests");
		fennec_test_spacer(2);
		fennec_test_containers_array();
		fennec_test_spacer(3);

		fennec_test_subheader("dynarray tests");
		fennec_test_spacer(2);
		fennec_test_containers_dynarray();
		fennec_test_spacer(3);

		fennec_test_subheader("list tests");
		fennec_test_spacer(2);
		fennec_test_containers_list();
		fennec_test_spacer(3);

		fennec_test_subheader("deque tests");
		fennec_test_spacer(2);
		fennec_test_containers_deque();
		fennec_test_spacer(3);

		fennec_test_subheader("set tests");
		fennec_test_spacer(2);
		fennec_test_containers_set();
		fennec_test_spacer(3);

		fennec_test_subheader("bintree tests");
		fennec_test_spacer(2);
		fennec_test_containers_bintree();
		fennec_test_spacer(3);

		fennec_test_subheader("sequence tests");
		fennec_test_spacer(2);
		fennec_test_containers_sequence();
		fennec_test_spacer(3);

		fennec_test_subheader("priority queue tests");
		fennec_test_spacer(2);
		fennec_test_containers_priority_queue();
		fennec_test_spacer(3);

		fennec_test_subheader("map tests");
		fennec_test_spacer(2);
		fennec_test_containers_map();
		fennec_test_spacer(3);

		fennec_test_subheader("object_pool tests");
		fennec_test_spacer(2);
		fennec_test_containers_object_pool();
		fennec_test_spacer(3);

		fennec_test_subheader("rdtree tests");
		fennec_test_spacer(2);
		fennec_test_containers_rdtree();
		fennec_test_spacer(3);

		fennec_test_subheader("graph tests");
		fennec_test_spacer(2);
		fennec_test_containers_graph();

		// TODO
	}

}

#endif // FENNEC_TEST_CONTAINERS_H
